#
Summary: This will configure the xntp3d config files for Fermilab. 
Name: zz_xntp3_change
Version: 1.1
Release: 2
Copyright: GPL
Group: Fermi
URL: http://www.fnal.gov/cd/UNIX/linux/
Distribution: Fermi Linux v6.1.1
Vendor: Fermilab
Packager: Dan Yocum
requires: xntp3,perl
%description

This package configures the xntp3 time daemon correctly for use at Fermilab.  It
sets the initial time from the nameservers (131.225.8.120 and 131.225.17.150) 
and configures xntpd to listen to time broadcasts from the local router of the
subdomain that the machine is on.

Both the /etc/ntp.conf and /etc/rc.d/init.d/xntpd will be saved with a suffix 
of .rpmsave.

%files
%post

#
# This modifies /etc/rc.d/init.d/xntpd
#
mv /etc/rc.d/init.d/xntpd /etc/rc.d/init.d/xntpd.rpmsave
if [ `grep 'hwclock --systohc' /etc/rc.d/init.d/xntpd.rpmsave | wc -l ` -eq 0 ]
then
cat /etc/rc.d/init.d/xntpd.rpmsave | sed '/# Start daemons./i\
\
        # Uncomment to auto-set the hardware clock\
        \/sbin\/hwclock --systohc\
\ ' > /etc/rc.d/init.d/xntpd.hwclk
else 
cp /etc/rc.d/init.d/xntpd.rpmsave /etc/rc.d/init.d/xntpd.hwclk
fi

if [ `grep CLOCKFLAGS /etc/rc.d/init.d/xntpd.hwclk | wc -l ` -eq 0 ]
then
cat /etc/rc.d/init.d/xntpd.hwclk | sed '/# See how we were called./i\
\
# 1999/08/20 CG Source the clock configuration\
. \/etc\/sysconfig\/clock\
CLOCKFLAGS="--systohc"\
case "$UTC" in\
  yes|true)\
    CLOCKFLAGS="$CLOCKFLAGS -u";\
  ;;\
esac\
case "$ARC" in\
  yes|true)\
    CLOCKFLAGS="$CLOCKFLAGS -A";\
  ;;\
esac\
\ ' > /etc/rc.d/init.d/xntpd.utc
else
mv -f /etc/rc.d/init.d/xntpd.hwclk /etc/rc.d/init.d/xntpd.utc
fi

if [ `grep 131.225.8.120 /etc/rc.d/init.d/xntpd.utc | wc -l ` -eq 0 ]
then
perl -pe 's/(^\t\t\/usr\/sbin\/ntpdate -b -p 8 -u `cat \/etc\/ntp\/step-tickers`
)/\t\t\/usr\/sbin\/ntpdate -o 1 131.225.8.120 131.225.17.150/;' -i /etc/rc.d/init.d/xntpd.utc
fi

if [ `grep 'chkconfig: 2345 55 10' /etc/rc.d/init.d/xntpd.utc | wc -l` -eq 0 ]
then
perl -pe 's/(^# chkconfig: - 55 10)/# chkconfig: 2345 55 10/;' -i /etc/rc.d/init.d/xntpd.utc
fi

if [ -f /etc/rc.d/init.d/xntpd.hwclk ] 
then
	rm -f /etc/rc.d/init.d/xntpd.hwclk
fi

mv -f /etc/rc.d/init.d/xntpd.utc /etc/rc.d/init.d/xntpd
chmod 755 /etc/rc.d/init.d/xntpd

#
# This modifies /etc/ntp.conf
#

if [ -f /etc/ntp.conf.rpmsave ]
then
        mv /etc/ntp.conf.rpmsave /etc/ntp.conf.rpmsave.$$
fi

cp /etc/ntp.conf /etc/ntp.conf.rpmsave

if [ -f /tmp/ntp.sh ]
then
        rm -f /tmp/ntp.sh
fi

if [ -f /etc/sysconfig/network ]
then
	export ROUTER=`grep 'GATEWAY=' /etc/sysconfig/network`
	export BCCADDR=`echo $ROUTER | sed 's/GATEWAY=//'`
else
	export BCCADDR=`route -n | grep ^0.0.0.0 | cut -c17-32`
fi

echo "cat /etc/ntp.conf.rpmsave | sed '/fudge/a\\" > /tmp/ntp.sh
echo "\\" >> /tmp/ntp.sh
echo "enable bclient\\" >> /tmp/ntp.sh
echo "broadcastclient `echo $BCCADDR`' > /etc/ntp.conf" >> /tmp/ntp.sh

sh /tmp/ntp.sh
rm /tmp/ntp.sh

perl -pe 's/server/#server/;' -i /etc/ntp.conf
perl -pe 's/fudge/#fudge/;' -i /etc/ntp.conf
perl -pe 's/multicastclient/#multicastclient/;' -i /etc/ntp.conf

#
# This creates the files /etc/ntp/drift and /etc/ntp/step-tickers
#

/bin/touch /etc/ntp/drift
/bin/touch /etc/ntp/step-tickers

%postun

if [ -f /etc/ntp.conf -a -f /etc/ntp.conf.rpmsave ]
then
	mv -f /etc/ntp.conf.rpmsave /etc/ntp.conf
fi

if [ -f /etc/rc.d/init.d/xntpd -a -f /etc/rc.d/init.d/xntpd.rpmsave ]
then
	mv -f /etc/rc.d/init.d/xntpd.rpmsave /etc/rc.d/init.d/xntpd
fi

# This makes sure the daemon is added to the runlevels 2, 3, and 5
#

/sbin/chkconfig xntpd on
